import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
public class Mouse extends Actor
{
    int count = 0;
    int boost = 3;
    public Mouse()
    {
        getImage().scale(getImage().getWidth()/2, getImage().getHeight()/2);
    }
    public void act() 
    {
        moveAround();
        hitFood();
        hitTeleporter();
        youWin();
        youLose();
    }    
    public void moveAround()
    {
        if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("D"))
        {
            setLocation(getX() + boost, getY());
            if (hitWall())
            {
                setLocation(getX() - boost, getY());
            }
        }
        if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("A"))
        {
            setLocation(getX() - boost, getY());
            if (hitWall())
            {
                setLocation(getX() + boost, getY());
            }
        }
        if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("W"))
        {
         setLocation(getX(), getY() - boost);
         if (hitWall())
            {
                setLocation(getX(), getY() + boost);
            }
        }
        if (Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("S"))
        {
            setLocation(getX(), getY() + boost);
            if (hitWall())
            {
                setLocation(getX(), getY() - boost);
            }
        }
    }
    public boolean hitWall()
    {
        if (isTouching(Walls.class))
        {
            return true;
        }
        return false;
    }
    public void hitFood()
    {
        if(getOneIntersectingObject(Cheese.class) != null)
        {
            getWorld().removeObject(getOneIntersectingObject(Cheese.class));
            count++;
            boost ++;
        }
    }
    public void hitTeleporter()
    {
        if(isTouching(Teleporter.class))
        {
            setLocation(27, 561);
        }
    }
    public boolean hitEnemy()
    {
        if (isTouching(Enemy.class))
        {
            return true;
        }
        return false;
    }
    public void youLose()
    {
        if (hitEnemy())
        {
            getWorld().addObject(new YouLose(), 375, 275);
            Greenfoot.stop();
        }
    }
    public void youWin()
    {
        if (isTouching(Exit.class) && count == 10)
        {
            getWorld().addObject(new YouWin(), 375, 275);
            Greenfoot.stop();
        }
    }
}
